/**
 * validateapi
 * The validation APIs help you validate data. Check if an E-mail address is real. Check if a domain is real. Check up on an IP address, and even where it is located. All this and much more is available in the validation API.
 *
 * OpenAPI spec version: v1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CloudmersiveValidateApiClient) {
      root.CloudmersiveValidateApiClient = {};
    }
    root.CloudmersiveValidateApiClient.GeolocateStreetAddressResponse = factory(root.CloudmersiveValidateApiClient.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The GeolocateStreetAddressResponse model module.
   * @module model/GeolocateStreetAddressResponse
   * @version 1.4.8
   */

  /**
   * Constructs a new <code>GeolocateStreetAddressResponse</code>.
   * Geolocation street address result
   * @alias module:model/GeolocateStreetAddressResponse
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>GeolocateStreetAddressResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/GeolocateStreetAddressResponse} obj Optional instance to populate.
   * @return {module:model/GeolocateStreetAddressResponse} The populated <code>GeolocateStreetAddressResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('CountryCode')) {
        obj['CountryCode'] = ApiClient.convertToType(data['CountryCode'], 'String');
      }
      if (data.hasOwnProperty('CountryName')) {
        obj['CountryName'] = ApiClient.convertToType(data['CountryName'], 'String');
      }
      if (data.hasOwnProperty('StreetAddress')) {
        obj['StreetAddress'] = ApiClient.convertToType(data['StreetAddress'], 'String');
      }
      if (data.hasOwnProperty('City')) {
        obj['City'] = ApiClient.convertToType(data['City'], 'String');
      }
      if (data.hasOwnProperty('RegionName')) {
        obj['RegionName'] = ApiClient.convertToType(data['RegionName'], 'String');
      }
      if (data.hasOwnProperty('ZipCode')) {
        obj['ZipCode'] = ApiClient.convertToType(data['ZipCode'], 'String');
      }
    }
    return obj;
  }

  /**
   * Two-letter country code of IP address
   * @member {String} CountryCode
   */
  exports.prototype['CountryCode'] = undefined;
  /**
   * Country name of IP address
   * @member {String} CountryName
   */
  exports.prototype['CountryName'] = undefined;
  /**
   * Street address of IP address
   * @member {String} StreetAddress
   */
  exports.prototype['StreetAddress'] = undefined;
  /**
   * City of IP address
   * @member {String} City
   */
  exports.prototype['City'] = undefined;
  /**
   * State/region of IP address
   * @member {String} RegionName
   */
  exports.prototype['RegionName'] = undefined;
  /**
   * Zip or postal code of IP address
   * @member {String} ZipCode
   */
  exports.prototype['ZipCode'] = undefined;



  return exports;
}));


