/**
 * validateapi
 * The validation APIs help you validate data. Check if an E-mail address is real. Check if a domain is real. Check up on an IP address, and even where it is located. All this and much more is available in the validation API.
 *
 * OpenAPI spec version: v1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PublicHolidayOccurrence'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PublicHolidayOccurrence'));
  } else {
    // Browser globals (root is window)
    if (!root.CloudmersiveValidateApiClient) {
      root.CloudmersiveValidateApiClient = {};
    }
    root.CloudmersiveValidateApiClient.PublicHolidaysResponse = factory(root.CloudmersiveValidateApiClient.ApiClient, root.CloudmersiveValidateApiClient.PublicHolidayOccurrence);
  }
}(this, function(ApiClient, PublicHolidayOccurrence) {
  'use strict';




  /**
   * The PublicHolidaysResponse model module.
   * @module model/PublicHolidaysResponse
   * @version 1.4.8
   */

  /**
   * Constructs a new <code>PublicHolidaysResponse</code>.
   * Result of performing a get public holidays request operation
   * @alias module:model/PublicHolidaysResponse
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>PublicHolidaysResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PublicHolidaysResponse} obj Optional instance to populate.
   * @return {module:model/PublicHolidaysResponse} The populated <code>PublicHolidaysResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('Successful')) {
        obj['Successful'] = ApiClient.convertToType(data['Successful'], 'Boolean');
      }
      if (data.hasOwnProperty('PublicHolidays')) {
        obj['PublicHolidays'] = ApiClient.convertToType(data['PublicHolidays'], [PublicHolidayOccurrence]);
      }
    }
    return obj;
  }

  /**
   * True if successful, false otherwise
   * @member {Boolean} Successful
   */
  exports.prototype['Successful'] = undefined;
  /**
   * Public holidays in the requested country and year
   * @member {Array.<module:model/PublicHolidayOccurrence>} PublicHolidays
   */
  exports.prototype['PublicHolidays'] = undefined;



  return exports;
}));


