/**
 * validateapi
 * The validation APIs help you validate data. Check if an E-mail address is real. Check if a domain is real. Check up on an IP address, and even where it is located. All this and much more is available in the validation API.
 *
 * OpenAPI spec version: v1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SqlInjectionCheckRequestItem'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SqlInjectionCheckRequestItem'));
  } else {
    // Browser globals (root is window)
    if (!root.CloudmersiveValidateApiClient) {
      root.CloudmersiveValidateApiClient = {};
    }
    root.CloudmersiveValidateApiClient.SqlInjectionCheckBatchRequest = factory(root.CloudmersiveValidateApiClient.ApiClient, root.CloudmersiveValidateApiClient.SqlInjectionCheckRequestItem);
  }
}(this, function(ApiClient, SqlInjectionCheckRequestItem) {
  'use strict';




  /**
   * The SqlInjectionCheckBatchRequest model module.
   * @module model/SqlInjectionCheckBatchRequest
   * @version 1.4.8
   */

  /**
   * Constructs a new <code>SqlInjectionCheckBatchRequest</code>.
   * Input to a batch SQL Injection detection operation
   * @alias module:model/SqlInjectionCheckBatchRequest
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>SqlInjectionCheckBatchRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SqlInjectionCheckBatchRequest} obj Optional instance to populate.
   * @return {module:model/SqlInjectionCheckBatchRequest} The populated <code>SqlInjectionCheckBatchRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('RequestItems')) {
        obj['RequestItems'] = ApiClient.convertToType(data['RequestItems'], [SqlInjectionCheckRequestItem]);
      }
      if (data.hasOwnProperty('DetectionLevel')) {
        obj['DetectionLevel'] = ApiClient.convertToType(data['DetectionLevel'], 'String');
      }
    }
    return obj;
  }

  /**
   * Multiple items to detect for SQL Injection
   * @member {Array.<module:model/SqlInjectionCheckRequestItem>} RequestItems
   */
  exports.prototype['RequestItems'] = undefined;
  /**
   * Set to Normal to target a high-security SQL Injection detection level with a very low false positive rate; select High to target a very-high security SQL Injection detection level with higher false positives.  Default is Normal (recommended).
   * @member {String} DetectionLevel
   */
  exports.prototype['DetectionLevel'] = undefined;



  return exports;
}));


